package com.steerinfo.baseinfo.meterbaseprint.controller;

import com.steerinfo.baseinfo.meterbaseprint.model.MeterBasePrint;
import com.steerinfo.baseinfo.meterbaseprint.service.IMeterBasePrintService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import oracle.jdbc.proxy.annotation.Post;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBasePrint RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-07-09 10:12
 * 类描述
 * 修订历史：
 * 日期：2022-07-09
 * 作者：generator
 * 参考：
 * 描述：MeterBasePrint RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbaseprints")
public class MeterBasePrintController extends BaseRESTfulController {

    @Autowired
    IMeterBasePrintService meterBasePrintService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseprint:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBasePrint> list = meterBasePrintService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaseprint:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBasePrint> list = meterBasePrintService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterBasePrint对象创建")
    @ApiImplicitParam(name = "meterBasePrint", value = "详细实体meterBasePrint", required = true, dataType = "MeterBasePrint")
    //@RequiresPermissions("meterbaseprint:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterBasePrint model){
        model.setPrintDate(new Date());
        MeterBasePrint meterBasePrint = meterBasePrintService.add(model);
        return success(meterBasePrint);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseprint:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBasePrint meterBasePrint = meterBasePrintService.getById(id);
        return success(meterBasePrint);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBasePrint信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBasePrint", value = "详细实体meterBasePrint", required = true, dataType = "MeterBasePrint")
    })
    //@RequiresPermissions("meterbaseprint:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBasePrint model){
        model.setId(id);
        MeterBasePrint meterBasePrint = meterBasePrintService.modify(model);
        return success(meterBasePrint);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaseprint:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBasePrintService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="更新详细信息", notes="根据传过来的meterBasePrint信息来更新详细信息")
    //@RequiresPermissions("meterbaseprint:update")
    @PostMapping(value = "/updateModel", produces  = "application/json;charset=UTF-8")
    public RESTfulResult updateModel(@RequestBody MeterBasePrint model){
        model.setId(model.getPrintId());
        model.setPrintDate(new Date());
        MeterBasePrint meterBasePrint = meterBasePrintService.modify(model);
        return success(meterBasePrint);
    }

    @ApiOperation(value = "获取打印次数信息", notes = "获取打印次数信息")
    //@RequiresPermissions("meterworkrailwayactual:view")
    @GetMapping(value = "/noPage/")
    public RESTfulResult noPage(@RequestParam HashMap params) {
        try {
            RESTfulResult rm  = meterBasePrintService.noPage(params);
            return rm;
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }
}
